
#ifndef __APPBAR_H__INCLUDED__
#define __APPBAR_H__INCLUDED__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "scbarcf.h"
#include "orderer.h"

/////////////////////////////////////////////////////////////////////////////

#define ABS_DOCKABLE 0x40000000
#define ABS_VISIBLE 0x80000000
#define ABS_DOCKLEFT AFX_IDW_DOCKBAR_LEFT
#define ABS_DOCKRIGHT AFX_IDW_DOCKBAR_RIGHT
#define ABS_DOCKTOP AFX_IDW_DOCKBAR_TOP
#define ABS_DOCKBOTTOM AFX_IDW_DOCKBAR_BOTTOM
#define ABS_DOCK (ABS_DOCKLEFT|ABS_DOCKRIGHT|ABS_DOCKTOP|ABS_DOCKBOTTOM)

/////////////////////////////////////////////////////////////////////////////
// CAppBar window

#ifndef baseCAppBar
// #define baseCAppBar CSizingControlBar
#define baseCAppBar CSizingControlBarCF
#endif

#pragma warning ( disable : 4512 )
class CAppBar : public baseCAppBar, public COrderer
  {
    // Construction
public :
    CAppBar ();

    // Attributes
public :
    DWORD m_dwFlags;

protected :
    // CButton m_butBottom;

    // Overridables
public :
    virtual void OnUpdateCmdUI (CFrameWnd * pTarget, BOOL bDisableIfNoHndler);

    // Operations
public :
    bool CreateBar (LPCTSTR pszName, LPRECT rect, DWORD dwStyle, DWORD nFlags, DWORD id, CFrameWnd *pParent);

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CAppBar)
    //}}AFX_VIRTUAL
    bool LoadPlacement (DWORD *pdwFlags = NULL, LPPOINT pptFloat = NULL);
    bool SavePlacement ();
    virtual CString GetName () = 0;

    // Implementation
public :
    virtual ~CAppBar ();

    // Generated message map functions
protected :
    //{{AFX_MSG(CAppBar)
    afx_msg int OnCreate (LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnSize (UINT nType, int cx, int cy);
    afx_msg void OnDestroy ();
  	afx_msg void OnCmdClose();
  	afx_msg void OnCmdDockable();
    afx_msg void OnRButtonUp (UINT nFlags, CPoint point);
    afx_msg LONG OnAppendMenu (WPARAM wParam, LPARAM lParam);
    afx_msg LONG OnProcessMenu (WPARAM wParam, LPARAM lParam);
    afx_msg LONG OnAppendProps (WPARAM wParam, LPARAM lParam);
    afx_msg void OnProperties ();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP ()
  };
#pragma warning ( default : 4512 )

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // __APPBAR_H__INCLUDED__
