
#include "stdafx.h"
#include "apptreec.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning ( disable : 4711 )
/////////////////////////////////////////////////////////////////////////////
// CAppTreeCtrl

CAppTreeCtrl::CAppTreeCtrl ()
{
}

CAppTreeCtrl:: ~ CAppTreeCtrl ()
{
}

void CAppTreeCtrl::
CheckSelection ()
{
  POSITION pos = GetFirstSelectedItemPosition (), oldpos;
  HTREEITEM hItem;
  TVITEM item;
  item.mask = TVIF_HANDLE|TVIF_PARAM;
  while (pos)
    {
      oldpos = pos;
      hItem = GetNextSelectedItem (pos);
      if (!GetItem (&item))
        {
          m_listSelected.RemoveAt (oldpos);
        }
    }
}

/* it's too time consuming
void CAppTreeCtrl::
RemoveState (HTREEITEM hItem, LPARAM lParam)
{
  if (GetItemState (hItem, lParam) & lParam)
    {
      SetItemState (hItem, 0, lParam);
    }
}
 */

void CAppTreeCtrl::
ClearSelection ()
{
  /* it's too time consuming
  ProcessItemsBefore (RemoveState, TVI_ROOT, TVIS_SELECTED, FALSE);
   */
  POSITION pos = GetFirstSelectedItemPosition ();
  HTREEITEM hItem;
  while (pos)
    {
      hItem = GetNextSelectedItem (pos);
      SetItemState (hItem, 0, TVIS_SELECTED);
    }
  m_listSelected.RemoveAll ();
}

void CAppTreeCtrl::
ClearSelectionBut (HTREEITEM hButItem)
{
  POSITION pos = GetFirstSelectedItemPosition ();
  HTREEITEM hItem;
  while (pos)
    {
      hItem = GetNextSelectedItem (pos);
      if (hButItem != hItem)
      {
        SetItemState (hItem, 0, TVIS_SELECTED);
      }
    }
  m_listSelected.RemoveAll ();
  m_listSelected.AddTail (hButItem);
}

UINT CAppTreeCtrl::
GetSelectedCount () const
{
  return m_listSelected.GetCount ();
}

POSITION CAppTreeCtrl::
GetFirstSelectedItemPosition () const
{
  return m_listSelected.GetHeadPosition ();
}

HTREEITEM CAppTreeCtrl::
GetNextSelectedItem(POSITION &pos) const
{
  ASSERT (pos);
  return m_listSelected.GetNext (pos);
}

/*
  hEnd == 0 - searching for the beginning of the selection
  hEnd == 1 - selecting and searching for the beginning
              of the selection
  hEnd == 2 - selecting and searching for the end of the selection
              by the last selected item
  hEnd == 3 - searching for the end of the selection
  hEnd == 4 - clearing the rest
 */
void CAppTreeCtrl::
SetSelectedTo (HTREEITEM hItem, LPARAM lParam)
{
  if (((HTREEITEM2X*) lParam)->hEnd == (HTREEITEM) 4)
    {
      if (GetItemState (hItem, TVIS_SELECTED) & TVIS_SELECTED)
        {
          SetItemState (hItem, 0, TVIS_SELECTED);
          m_listSelected.RemoveAt (m_listSelected.Find(hItem));
        }
    }
  else
    {
      switch ((DWORD) ((HTREEITEM2X*) lParam)->hEnd)
        {
        case 0:
          if (hItem == ((HTREEITEM2X*) lParam)->hBegin)
            {
              ((HTREEITEM2X*) lParam)->hEnd = (HTREEITEM) 1;
              if (!(GetItemState (hItem, TVIS_SELECTED) & TVIS_SELECTED))
                {
                  SetItemState (hItem, TVIS_SELECTED, TVIS_SELECTED);
                  m_listSelected.AddTail (hItem);
                }
            }
          else if (GetItemState (hItem, TVIS_SELECTED) & TVIS_SELECTED)
            {
              ((HTREEITEM2X*) lParam)->hEnd = (HTREEITEM) 2;
            }
          break;
        case 1:
          if (GetItemState (hItem, TVIS_SELECTED) & TVIS_SELECTED)
            {
              // only to leave all selection under top-first item
              // ((HTREEITEM2X*) lParam)->hEnd = (HTREEITEM) 3;
              ((HTREEITEM2X*) lParam)->hEnd = (HTREEITEM) 4;
            }
          else
            {
              SetItemState (hItem, TVIS_SELECTED, TVIS_SELECTED);
              m_listSelected.AddTail (hItem);
            }
          break;
        case 2:
          if (!(GetItemState (hItem, TVIS_SELECTED) & TVIS_SELECTED))
            {
              SetItemState (hItem, TVIS_SELECTED, TVIS_SELECTED);
              m_listSelected.AddTail (hItem);
            }
          if (hItem == ((HTREEITEM2X*) lParam)->hBegin)
            {
              ((HTREEITEM2X*) lParam)->hEnd = (HTREEITEM) 4;
            }
          break;
        case 3:
          if (!(GetItemState (hItem, TVIS_SELECTED) & TVIS_SELECTED))
            {
              ((HTREEITEM2X*) lParam)->hEnd = (HTREEITEM) 4;
            }
          break;
        default:
          ASSERT (FALSE);
        }
    }
}

void CAppTreeCtrl::
SelectTo (HTREEITEM hItem)
{
  if (GetSelectedCount ())
    {
      if (hItem == m_listSelected.GetHead ())
        {
          ClearSelectionBut (hItem);
        }
      else
        {
          HTREEITEM2X items;
          items.hBegin = hItem;
          items.hEnd = (HTREEITEM) 0;
          ProcessItemsInOrder (SetSelectedTo, TVI_ROOT, (LPARAM) &items, FALSE);
        }
    }
  else
    {
      SetItemState (hItem, TVIS_SELECTED, TVIS_SELECTED);
      m_listSelected.AddTail (hItem);
    }
}

void CAppTreeCtrl::
AddToList (HTREEITEM hItem, LPARAM lParam)
{
  if (!((CList<HTREEITEM, HTREEITEM>*) lParam)->Find (hItem))
    {
      ((CList<HTREEITEM, HTREEITEM>*) lParam)->AddTail (hItem);
    }
}

int CAppTreeCtrl::
GetChildren (HTREEITEM hItem, CList<HTREEITEM, HTREEITEM> &list, BOOL bSelf)
{
  int nCount = list.GetCount ();
  ProcessItemsInOrder (AddToList, hItem, (LPARAM) &list, bSelf);
  return list.GetCount () - nCount;
}

BOOL CAppTreeCtrl::
EqualItem (TVITEM * pItem, LPCTSTR text, int image, LPARAM lParam, UINT mask)
{
  if (GetItem (pItem))
    {
      if (mask & TVIF_TEXT && _tcsicmp (text, pItem->pszText))
        return FALSE;
      if (mask & TVIF_IMAGE && image != pItem->iImage)
        return FALSE;
      if (mask & TVIF_PARAM && lParam != pItem->lParam)
        return FALSE;
      return TRUE;
    }
  return FALSE;
}

bool CAppTreeCtrl::
FindFirstItemAfter (bool (CAppTreeCtrl:: * FindFirstItem) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  HTREEITEM hParent = hItem;
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      if ((this->*FindFirstItem) (hItem, lParam))
        {
          return true;
        }
    }
  if (bSelf)
    {
      return (this->*FindFirstItem) (hParent, lParam);
    }
  return false;
}

bool CAppTreeCtrl::
FindFirstItemBack (bool (CAppTreeCtrl:: * FindFirstItem) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  if (bSelf)
    {
      if ((this->*FindFirstItem) (hItem, lParam))
        {
          return true;
        }
    }
  while ((hItem = GetParentItem (hItem)) != NULL)
    {
      if ((this->*FindFirstItem) (hItem, lParam))
        {
          return true;
        }
    }
  return false;
}

bool CAppTreeCtrl::
FindFirstItemBefore (bool (CAppTreeCtrl:: * FindFirstItem) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  if (bSelf)
    {
      if ((this->*FindFirstItem) (hItem, lParam))
        {
          return true;
        }
    }
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      if ((this->*FindFirstItem) (hItem, lParam))
        {
          return true;
        }
    }
  return false;
}

bool CAppTreeCtrl::
FindFirstItemInOrder (bool (CAppTreeCtrl:: * FindFirstItem) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  if (bSelf)
    {
      if ((this->*FindFirstItem) (hItem, lParam))
        {
          return true;
        }
    }
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      if (FindFirstItemInOrder (FindFirstItem, hItem, lParam, TRUE))
        {
          return true;
        }
    }
  return false;
}

bool CAppTreeCtrl::
FindFirstItemPostOrder (bool (CAppTreeCtrl:: * FindFirstItem) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  HTREEITEM hParent = hItem;
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      if (FindFirstItemPostOrder (FindFirstItem, hItem, lParam, TRUE))
        {
          return true;
        }
    }
  if (bSelf)
    {
      return (this->*FindFirstItem) (hParent, lParam);
    }
  return false;
}

bool CAppTreeCtrl::
FindFirstItemPreOrder (bool (CAppTreeCtrl:: * FindFirstItem) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  if (FindFirstItemBefore (FindFirstItem, hItem, lParam, bSelf))
    {
      return true;
    }
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      if (FindFirstItemPreOrder (FindFirstItem, hItem, lParam, FALSE))
        {
          return true;
        }
    }
  return false;
}

HTREEITEM CAppTreeCtrl::
FindItem (HTREEITEM hItem, LPCTSTR text, int image, LPARAM lParam, UINT mask, BOOL bSelf)
{
  TVITEM item;
  TCHAR buffer[32];

  item.mask = mask;
  if (mask & TVIF_TEXT)
    {
      item.pszText = buffer;
      item.cchTextMax = countof (buffer);
    }
  if (bSelf)
    {
      item.hItem = hItem;
      if (EqualItem (&item, text, image, lParam, mask))
        {
          return hItem;
        }
    }
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      item.hItem = hItem;
      if (EqualItem (&item, text, image, lParam, mask))
        {
          return hItem;
        }
    }
  return NULL;
}

HTREEITEM CAppTreeCtrl::
FindItemRecursive (HTREEITEM hItem, LPCTSTR text, int image, LPARAM lParam, UINT mask, BOOL bSelf)
{
  HTREEITEM hChild;
  TVITEM item;
  TCHAR buffer[32];

  item.mask = mask;
  if (mask & TVIF_TEXT)
    {
      item.pszText = buffer;
      item.cchTextMax = countof (buffer);
    }
  if (bSelf)
    {
      item.hItem = hItem;
      if (EqualItem (&item, text, image, lParam, mask))
        {
          return hItem;
        }
    }
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      hChild = FindItemRecursive (hItem, text, image, lParam, mask, TRUE);
      if (hChild)
        {
          return hChild;
        }
    }
  return NULL;
}

int CAppTreeCtrl::
GetItemLevel (HTREEITEM hItem)
{
  int nLevel = 0;

  while ((hItem = GetParentItem (hItem)) != NULL)
    {
      nLevel++;
    }
  return nLevel;
}

int CAppTreeCtrl::
GetItemCount (HTREEITEM hItem)
{
  int nCount = 0;

  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      nCount++;
    }
  return nCount;
}

int CAppTreeCtrl::
GetItemCountRecursive (HTREEITEM hItem)
{
  int nCount = 0;

  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      nCount += GetItemCountRecursive (hItem) + 1;
    }
  return nCount;
}

BOOL CAppTreeCtrl::
DataNotEqual (HTREEITEM hItem, LPARAM lParam)
{
  return GetItemData (hItem) != (DWORD) lParam;
}

int CAppTreeCtrl::
GetTrueItemCount (BOOL (CAppTreeCtrl:: * IsTrue) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  int nCount = 0;

  if (bSelf)
    {
      if ((this->*IsTrue) (hItem, lParam))
        {
          nCount++;
        }
    }
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      if ((this->*IsTrue) (hItem, lParam))
        {
          nCount++;
        }
    }
  return nCount;
}

int CAppTreeCtrl::
GetTrueItemCountRecursive (BOOL (CAppTreeCtrl:: * IsTrue) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  int nCount = 0;

  if (bSelf)
    {
      if ((this->*IsTrue) (hItem, lParam))
        {
          nCount++;
        }
    }
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      nCount += GetTrueItemCountRecursive (IsTrue, hItem, lParam, TRUE);
    }
  return nCount;
}

void CAppTreeCtrl::
ProcessItemsAfter (void (CAppTreeCtrl:: * ProcessItem) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  HTREEITEM hParent = hItem;
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      (this->*ProcessItem) (hItem, lParam);
    }
  if (bSelf)
    {
      (this->*ProcessItem) (hParent, lParam);
    }
}

void CAppTreeCtrl::
ProcessItemsBack (void (CAppTreeCtrl:: * ProcessItem) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  if (bSelf)
    {
      (this->*ProcessItem) (hItem, lParam);
    }
  while ((hItem = GetParentItem (hItem)) != NULL)
    {
      (this->*ProcessItem) (hItem, lParam);
    }
}

void CAppTreeCtrl::
ProcessItemsBefore (void (CAppTreeCtrl:: * ProcessItem) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  if (bSelf)
    {
      (this->*ProcessItem) (hItem, lParam);
    }
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      (this->*ProcessItem) (hItem, lParam);
    }
}

void CAppTreeCtrl::
ProcessItemsInOrder (void (CAppTreeCtrl:: * ProcessItem) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  if (bSelf)
    {
      (this->*ProcessItem) (hItem, lParam);
    }
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      ProcessItemsInOrder (ProcessItem, hItem, lParam, TRUE);
    }
}

void CAppTreeCtrl::
ProcessItemsPostOrder (void (CAppTreeCtrl:: * ProcessItem) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  HTREEITEM hParent = hItem;
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      ProcessItemsPostOrder (ProcessItem, hItem, lParam, TRUE);
    }
  if (bSelf)
    {
      (this->*ProcessItem) (hParent, lParam);
    }
}

void CAppTreeCtrl::
ProcessItemsPreOrder (void (CAppTreeCtrl:: * ProcessItem) (HTREEITEM hItem, LPARAM lParam), HTREEITEM hItem, LPARAM lParam, BOOL bSelf)
{
  ProcessItemsBefore (ProcessItem, hItem, lParam, bSelf);
  for (hItem = GetNextItem (hItem, TVGN_CHILD); hItem; hItem = GetNextItem (hItem, TVGN_NEXT))
    {
      ProcessItemsPreOrder (ProcessItem, hItem, lParam, FALSE);
    }
}

void CAppTreeCtrl::
Paint (void)
{
  RedrawWindow ();
}

BEGIN_MESSAGE_MAP (CAppTreeCtrl, CTreeCtrl)
//{{AFX_MSG_MAP(CAppTreeCtrl)
ON_WM_CREATE ()
//}}AFX_MSG_MAP
END_MESSAGE_MAP ()

/////////////////////////////////////////////////////////////////////////////
// CAppTreeCtrl message handlers

int CAppTreeCtrl::OnCreate (LPCREATESTRUCT lpCreateStruct)
{
  if (CTreeCtrl::OnCreate (lpCreateStruct) == -1)
    return -1;

  return 0;
}

BOOL CAppTreeCtrl::
PreTranslateMessage (MSG * pMsg)
{
  if (!GetEditControl () && pMsg->message == WM_KEYDOWN)
    {
      if (pMsg->wParam == VK_ESCAPE)
        {
          CWnd *w = AfxGetMainWnd ();

          w->SetForegroundWindow ();
          w->SetFocus ();
          return TRUE;
        }
      else if (pMsg->wParam == VK_F2)
        {
          HTREEITEM hItem = GetSelectedItem ();

          if (hItem)
            {
              EditLabel (hItem);
            }
        }
    }
  return CTreeCtrl::PreTranslateMessage (pMsg);
}

/////////////////////////////////////////////////////////////////////////////
#pragma warning ( default : 4711 )
