///////////////////////////////////////////////////////////////////////////
//  File:    editpad.h
//  Version: 1.1.0.4
//  Updated: 19-Jul-1998
//
//  Copyright:  Ferdinand Prantl, portions by Stcherbatchenko Andrei
//  E-mail:     prantl@ff.cuni.cz
//
//  Application core
//
//  You are free to use or modify this code to the following restrictions:
//  - Acknowledge me somewhere in your about box, simple "Parts of code by.."
//  will be enough. If you can't (or don't want to), contact me personally.
//  - LEAVE THIS HEADER INTACT
////////////////////////////////////////////////////////////////////////////

// editpad.h : main header file for the EDITPAD application
//

#if !defined(AFX_EDITPAD_H__C9FC90C5_018F_11D3_9ACA_00600875DD5F__INCLUDED_)
#define AFX_EDITPAD_H__C9FC90C5_018F_11D3_9ACA_00600875DD5F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"           // main symbols

#define REGISTRY_ROOT _T ("Software\\EditPad\\IDE\\")

/////////////////////////////////////////////////////////////////////////////
// CEditPadApp:
// See editpad.cpp for the implementation of this class
//

#define EP_OPEN_LAST_DOCS 1
#define EP_CREATE_NEW_DOC_NEVER 0
#define EP_CREATE_NEW_DOC_ALWAYS 2
#define EP_CREATE_NEW_DOC_IF_ALONE 4
#define EP_MAXIMIZE_FRAME_WND 8
#define EP_MAXIMIZE_CHILD_WND 16
#define EP_SAVE_DOCS_ON_EXIT 32
#define EP_SAVE_SETS_ON_EXIT 64
#define EP_DRAG_N_DROP_EDIT 128
#define EP_AUTO_RELOAD 256
#define EP_NOTIFY_CHANGES 512
#define EP_ADVANCED_UI 1024
#define EP_OPEN_LAST_PRJ 2048
#define EP_NO_SPLASH 4096
#define EP_REMEMBER_LASTPOS 8192

class CEditPadApp : public CWinApp
  {
public :
    CEditPadApp ();
    ~CEditPadApp ();

    DWORD m_dwFlags;
    CString m_sLastDocs;
    CList<CString, LPCTSTR> m_lstProjects;

    DWORD GetFlags ();
    void SetFlags (DWORD dwFlags);

    void LoadSettings ();
    void LoadLastDocs ();
    void SaveSettings ();
    void SaveLastDocs ();

    void LoadCustomState ();
    void SaveCustomState ();
    BOOL ShowPopupMenu (UINT uiMenuResId, const CPoint &point, CWnd *pWnd);

    bool NewProject ();
    bool OpenProject (LPCTSTR pszPath);
    bool OpenProject ();
    bool SaveProject (LPCTSTR pszPath);
    bool SaveProject ();
    bool SaveProjectAs ();

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CEditPadApp)
	public:
    virtual BOOL InitInstance ();
    virtual BOOL ExitInstance ();
    //}}AFX_VIRTUAL
    void ParseCommandLine(CCommandLineInfo &rCmdInfo); //  by Serge Weinstock
    CString	m_OneArg;
    CDocument *OpenDocumentFileEx (LPCTSTR lpszFileName, int nType);

    // Implementation
    //{{AFX_MSG(CEditPadApp)
    afx_msg void OnFileNew ();
    afx_msg void OnFileOpen ();
    afx_msg void OnAppAbout ();
    afx_msg void OnTipOfTheDay ();
    afx_msg void OnFileSaveAll ();
    afx_msg void OnViewOptionsGeneral();
    afx_msg void OnUpdateToolsSpellingSet (CCmdUI * pCmdUI);
    afx_msg void OnToolsSpellingSet ();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP ()

    CBCGKeyboardManager m_KeyboardManager;
    CBCGContextMenuManager m_ContextMenuManager;
  };

extern CEditPadApp theApp;


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITPAD_H__C9FC90C5_018F_11D3_9ACA_00600875DD5F__INCLUDED_)
