///////////////////////////////////////////////////////////////////////////
//  File:    epricdoc.h
//  Version: 1.6.0.9
//  Updated: 18-Oct-1999
//
//  RTF Document core
//
//  Copyright:  Ferdinand Prantl, portions by Stcherbatchenko Andrei
//  E-mail:     prantl@ff.cuni.cz
//
//  You are free to use or modify this code to the following restrictions:
//  - Acknowledge me somewhere in your about box, simple "Parts of code by.."
//  will be enough. If you can't (or don't want to), contact me personally.
//  - LEAVE THIS HEADER INTACT
////////////////////////////////////////////////////////////////////////////

// editpaddoc.h : interface of the CEditPadRichDoc class
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __EPRICDOC_INCLUDED__
#define __EPRICDOC_INCLUDED__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "filevent.h"

#define FA_WRITTEN	1
#define FA_FILELOST	2

class CEditPadRichDoc : public CRichEditDoc, public CFileEvent
  {
protected :                   // create from serialization only
    CEditPadRichDoc ();
    DECLARE_DYNCREATE (CEditPadRichDoc)

    // Attributes
public :
  	virtual void OnFileEvent (WPARAM wEvent, LPCTSTR pszPathName);

    // Operations
public:

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CEditPadRichDoc)
	public:
    virtual BOOL OnNewDocument ();
    virtual void Serialize (CArchive & ar);
    virtual void DeleteContents ();
    virtual BOOL OnOpenDocument (LPCTSTR lpszPathName);
    virtual BOOL OnSaveDocument (LPCTSTR lpszPathName);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL
  virtual CRichEditCntrItem* CreateClientItem(REOBJECT* preo) const;
	virtual BOOL SaveModified();

    // Implementation
public:
    virtual ~CEditPadRichDoc ();
#ifdef _DEBUG
    virtual void AssertValid ()const;
    virtual void Dump (CDumpContext & dc) const;
#endif

    // Generated message map functions
protected:
    //{{AFX_MSG(CEditPadRichDoc)
    afx_msg void OnReadOnly ();
    afx_msg void OnUpdateReadOnly (CCmdUI * pCmdUI);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP ()
  };

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // __EPRICDOC_INCLUDED__
