///////////////////////////////////////////////////////////////////////////
//  File:    epricvw.h
//  Version: 1.6.0.9
//  Updated: 18-Oct-1999
//
//  RTF View core
//
//  Copyright:  Ferdinand Prantl
//  E-mail:     prantl@ff.cuni.cz
//
//  You are free to use or modify this code to the following restrictions:
//  - Acknowledge me somewhere in your about box, simple "Parts of code by.."
//  will be enough. If you can't (or don't want to), contact me personally.
//  - LEAVE THIS HEADER INTACT
////////////////////////////////////////////////////////////////////////////

// editpadview.h : interface of the CEditPadRichView class
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __EPRICVW_INCLUDED__
#define __EPRICVW_INCLUDED__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "richevw2.h"

class CEditPadRichView : public CRichEditView2
  {
protected :                   // create from serialization only
    CEditPadRichView ();
    DECLARE_DYNCREATE (CEditPadRichView)

    // Attributes
public :
    CEditPadRichDoc * GetDocument ();

    // Operations
public :

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CEditPadRichView)
	public:
    virtual BOOL PreCreateWindow (CREATESTRUCT & cs);
	protected:
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	//}}AFX_VIRTUAL

    // Implementation
public :
    virtual ~CEditPadRichView ();
#ifdef _DEBUG
    virtual void AssertValid () const;
    virtual void Dump (CDumpContext & dc) const;
#endif

protected :

    // Generated message map functions
protected :
    //{{AFX_MSG(CEditPadRichView)
    afx_msg void OnContextMenu (CWnd * pWnd, CPoint point);
    afx_msg void OnViewOptions ();
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnFileReload ();
    afx_msg void OnUpdateFileReload (CCmdUI* pCmdUI);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP ()
  };

#ifndef _DEBUG                  // debug version in editpadview.cpp
inline CEditPadRichDoc *CEditPadRichView::
GetDocument ()
{
  return (CEditPadRichDoc*) m_pDocument;
}
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // __EPRICVW_INCLUDED__
