
#ifndef __SHFILEINFO_H__
#define __SHFILEINFO_H__

/////////////////////////////////////////////////////////////////////////////
// CSHFileInfo class

class CSHFileInfo
  {
    // Construction
public :
    CSHFileInfo (LPCTSTR lpszFileName = NULL);
    CSHFileInfo (CFileFind * pFoundFile);

    // Attributes
public :
    int m_iImageIndex;
    CString m_strPath;
    CString m_strInitDir;
    CString m_strSelDir;
    CString m_strTitle;
protected :
    CFileFind * m_pFoundFile;
    CString m_strFileName;
    TCHAR m_szDrive[_MAX_DRIVE];
    TCHAR m_szDir[_MAX_DIR];
    TCHAR m_szFname[_MAX_FNAME];
    TCHAR m_szExt[_MAX_EXT];

    // Operations
public :
    CString GetFileSize ();
    CString GetLastWriteTime ();
    CString GetDisplayName ();
    int GetIconIndex ();
    void SetFileName (LPCTSTR lpszFileName = NULL);
    CString GetFileName ();
    CString GetRoot ();
    CString GetFileTitle ();
    CString GetFileExt ();
    CString GetDescription ();
    bool Exist ();
    void GetSystemImageList (CImageList * pSmallList, CImageList * pLargeList);
    BOOL BrowseForFolder (CWnd * pParentWnd);

    // Implementation
public :
    virtual ~CSHFileInfo ();
  };

/////////////////////////////////////////////////////////////////////////////

#endif // __SHFILEINFO_H__
