///////////////////////////////////////////////////////////////////////////
//  File:    epbinvw.h
//  Version: 1.6.0.10
//  Updated: 23-Oct-1999
//
//  Binary View core
//
//  Copyright:  Ferdinand Prantl
//  E-mail:     prantl@ff.cuni.cz
//
//  You are free to use or modify this code to the following restrictions:
//  - Acknowledge me somewhere in your about box, simple "Parts of code by.."
//  will be enough. If you can't (or don't want to), contact me personally.
//  - LEAVE THIS HEADER INTACT
////////////////////////////////////////////////////////////////////////////

// epbinvw.h : interface of the CEditPadBinView class
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __EPBINVW_INCLUDED__
#define __EPBINVW_INCLUDED__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "hexedvw.h"

class CEditPadBinView : public CHexEditView
  {
protected :                   // create from serialization only
    CEditPadBinView ();
    DECLARE_DYNCREATE (CEditPadBinView)

    // Attributes
public :
    CEditPadBinDoc * GetDocument ();
    LPBYTE m_data;

    // Operations
public :

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CEditPadBinView)
	public:
    virtual BOOL PreCreateWindow (CREATESTRUCT & cs);
	protected:
	virtual void OnActivateView(BOOL bActivate, CHexEditView* pActivateView, CHexEditView* pDeactiveView);
  virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

    // Implementation
public :
    virtual ~CEditPadBinView ();
#ifdef _DEBUG
    virtual void AssertValid () const;
    virtual void Dump (CDumpContext & dc) const;
#endif

    // Generated message map functions
protected :
    //{{AFX_MSG(CEditPadBinView)
    afx_msg void OnContextMenu (CWnd * pWnd, CPoint point);
    afx_msg void OnViewOptions ();
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnFileReload ();
    afx_msg void OnUpdateFileReload (CCmdUI* pCmdUI);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP ()
  };

#ifndef _DEBUG                  // debug version in editpadview.cpp
inline CEditPadBinDoc *CEditPadBinView::
GetDocument ()
{
  return (CEditPadBinDoc*) m_pDocument;
}
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // __EPBINVW_INCLUDED__
