///////////////////////////////////////////////////////////////////////////
//  File:    editpadview.h
//  Version: 1.1.0.4
//  Updated: 19-Jul-1998
//
//  View core
//
//  Copyright:  Ferdinand Prantl, portions by Stcherbatchenko Andrei
//  E-mail:     prantl@ff.cuni.cz
//
//  You are free to use or modify this code to the following restrictions:
//  - Acknowledge me somewhere in your about box, simple "Parts of code by.."
//  will be enough. If you can't (or don't want to), contact me personally.
//  - LEAVE THIS HEADER INTACT
////////////////////////////////////////////////////////////////////////////

// editpadview.h : interface of the CEditPadView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EDITPADVIEW_H__BC121A98_FEE3_11D2_9ACA_00600875DD5F__INCLUDED_)
#define AFX_EDITPADVIEW_H__BC121A98_FEE3_11D2_9ACA_00600875DD5F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CrystalEditViewEx.h"
#include "CrystalParser.h"

class CEditPadView : public CCrystalEditViewEx
  {
protected :                   // create from serialization only
    CEditPadView ();
    DECLARE_DYNCREATE (CEditPadView)

    // Attributes
public :
    CEditPadDoc * GetDocument ();
    CCrystalParser m_xParser;

    // Operations
public :
    virtual CCrystalTextBuffer *LocateTextBuffer ();

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CEditPadView)
public :
    //  virtual void OnDraw(CDC* pDC);  // overridden to draw this view
    virtual BOOL PreCreateWindow (CREATESTRUCT & cs);
protected :
    //  virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
    //  virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
    //  virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
    //}}AFX_VIRTUAL

    // Implementation
public :
    virtual ~CEditPadView ();
#ifdef _DEBUG
    virtual void AssertValid () const;
    virtual void Dump (CDumpContext & dc) const;
#endif

protected :

    // Generated message map functions
protected :
    //{{AFX_MSG(CEditPadView)
    afx_msg void OnContextMenu (CWnd * pWnd, CPoint point);
    afx_msg void OnViewOptions ();
    afx_msg int OnCreate (LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnFileReload ();
    afx_msg void OnUpdateFileReload (CCmdUI* pCmdUI);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP ()
  };

#ifndef _DEBUG                  // debug version in editpadview.cpp
inline CEditPadDoc *CEditPadView::
GetDocument ()
{
  return (CEditPadDoc *) m_pDocument;
}
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITPADVIEW_H__BC121A98_FEE3_11D2_9ACA_00600875DD5F__INCLUDED_)
