///////////////////////////////////////////////////////////////////////////
//  File:    mainfrm.h
//  Version: 1.1.0.4
//  Updated: 19-Jul-1998
//
//  Main frame core
//
//  Copyright:  Ferdinand Prantl, portions by Stcherbatchenko Andrei
//  E-mail:     prantl@ff.cuni.cz
//
//  You are free to use or modify this code to the following restrictions:
//  - Acknowledge me somewhere in your about box, simple "Parts of code by.."
//  will be enough. If you can't (or don't want to), contact me personally.
//  - LEAVE THIS HEADER INTACT
////////////////////////////////////////////////////////////////////////////

// mainfrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__BC121A94_FEE3_11D2_9ACA_00600875DD5F__INCLUDED_)
#define AFX_MAINFRM_H__BC121A94_FEE3_11D2_9ACA_00600875DD5F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "statbar.h"

class CMainFrame : public CBCGFrameWnd
  {

protected :                   // create from serialization only
    CMainFrame ();
    DECLARE_DYNCREATE (CMainFrame)

    // Attributes
protected :
    CSplitterWnd m_wndSplitter;
  	// BOOL m_bFirst;
	bool m_bFullScreen;
	BOOL m_bGotFocus;

private:
	// used for full-screen mode
	bool m_bStatusBarWasVisible; // , m_bToolBarWasVisible;
	CRect	m_mainRect;
	CToolBar *m_pwndFullScreenBar;
	bool m_bMax;

    // Operations
public :

  void FullScreenOn ();
	void FullScreenOff ();

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CMainFrame)
public :
    virtual BOOL OnCreateClient (LPCREATESTRUCT lpcs, CCreateContext * pContext);
    virtual BOOL PreCreateWindow (CREATESTRUCT & cs);
  	// virtual void ActivateFrame(int nCmdShow = -1);
    //}}AFX_VIRTUAL

    // Implementation
public :
    virtual ~CMainFrame ();
#ifdef _DEBUG
    virtual void AssertValid () const;
    virtual void Dump (CDumpContext & dc) const;
#endif
	void FlashUntilFocus ();

protected :                   // control bar embedded members
    CEditStatusBar m_wndStatusBar;
    CBCGMenuBar m_wndMenuBar;
    CBCGToolBar m_wndToolBar;
    CBCGToolBarImages m_UserImages;

    // Generated message map functions
protected :
    //{{AFX_MSG(CMainFrame)
    afx_msg int OnCreate (LPCREATESTRUCT lpCreateStruct);
  	afx_msg void OnClose ();
  	afx_msg void OnSetFocus (CWnd *pOldWnd);
	  afx_msg void OnViewFullScreen ();
	  afx_msg void OnUpdateViewFullScreen (CCmdUI *pCmdUI);
    afx_msg void OnEncoding(UINT nID);
    afx_msg void OnUpdateEncoding(CCmdUI* pCmdUI);
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP ()
    afx_msg void OnViewCustomize ();
    afx_msg LRESULT OnToolbarReset (WPARAM, LPARAM);
    void OnToolsViewUserToolbar (UINT id);
    void OnUpdateToolsViewUserToolbar (CCmdUI* pCmdUI);
    afx_msg LRESULT OnToolbarContextMenu (WPARAM, LPARAM);
    afx_msg LRESULT OnHelpCustomizeToolbars (WPARAM wp, LPARAM lp);
  };

/////////////////////////////////////////////////////////////////////////////

class CMainFrame2 : public CFrameWnd
  {

protected :                   // create from serialization only
    CMainFrame2 ();
    DECLARE_DYNCREATE (CMainFrame2)

    // Attributes
protected :
    CSplitterWnd m_wndSplitter;
  	// BOOL m_bFirst;
	bool m_bFullScreen;
	BOOL m_bGotFocus;

private:
	// used for full-screen mode
	bool m_bStatusBarWasVisible; // , m_bToolBarWasVisible;
	CRect	m_mainRect;
	CToolBar *m_pwndFullScreenBar;
	bool m_bMax;

    // Operations
public :

  void FullScreenOn ();
	void FullScreenOff ();

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CMainFrame2)
public :
    virtual BOOL OnCreateClient (LPCREATESTRUCT lpcs, CCreateContext * pContext);
    virtual BOOL PreCreateWindow (CREATESTRUCT & cs);
  	// virtual void ActivateFrame(int nCmdShow = -1);
    //}}AFX_VIRTUAL

    // Implementation
public :
    virtual ~CMainFrame2 ();
#ifdef _DEBUG
    virtual void AssertValid () const;
    virtual void Dump (CDumpContext & dc) const;
#endif
	void FlashUntilFocus ();

protected :                   // control bar embedded members
    CEditStatusBar m_wndStatusBar;
    CToolBar m_wndToolBar;

    // Generated message map functions
protected :
    //{{AFX_MSG(CMainFrame2)
    afx_msg int OnCreate (LPCREATESTRUCT lpCreateStruct);
  	afx_msg void OnClose ();
  	afx_msg void OnSetFocus (CWnd *pOldWnd);
	  afx_msg void OnViewFullScreen ();
	  afx_msg void OnUpdateViewFullScreen (CCmdUI *pCmdUI);
    afx_msg void OnEncoding(UINT nID);
    afx_msg void OnUpdateEncoding(CCmdUI* pCmdUI);
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP ()
  };

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__BC121A94_FEE3_11D2_9ACA_00600875DD5F__INCLUDED_)
